"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse = void 0;
const scriptSetupAst_1 = require("./scriptSetupAst");
function parse(ts, content) {
    let exportDefault;
    const sourceFile = ts.createSourceFile('', content, ts.ScriptTarget.Latest);
    sourceFile.forEachChild(node => {
        if (ts.isExportAssignment(node)) {
            let obj;
            if (ts.isObjectLiteralExpression(node.expression)) {
                obj = node.expression;
            }
            else if (ts.isCallExpression(node.expression) && node.expression.arguments.length) {
                const arg0 = node.expression.arguments[0];
                if (ts.isObjectLiteralExpression(arg0)) {
                    obj = arg0;
                }
            }
            if (obj) {
                exportDefault = {
                    ..._getStartEnd(node),
                    args: _getStartEnd(obj),
                };
            }
        }
    });
    return {
        exportDefault,
    };
    function _getStartEnd(node) {
        return scriptSetupAst_1.getStartEnd(node, sourceFile);
    }
}
exports.parse = parse;
//# sourceMappingURL=scriptAst.js.map