"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
const findReferences = require("./references");
const commands_1 = require("../commands");
function register({ sourceFiles, tsLanguageService }) {
    const _findReferences = findReferences.register(arguments[0]);
    return (codeLens) => {
        var _a, _b, _c;
        const uri = codeLens.data.uri;
        const offset = codeLens.data.offset;
        const tsUri = codeLens.data.tsUri;
        const tsOffset = codeLens.data.tsOffset;
        const doc = uri ? (_b = (_a = sourceFiles.get(uri)) === null || _a === void 0 ? void 0 : _a.getTextDocument()) !== null && _b !== void 0 ? _b : tsLanguageService.__internal__.getTextDocument(uri) : undefined;
        const tsDoc = tsUri ? tsLanguageService.__internal__.getTextDocument(tsUri) : undefined;
        const sourceFile = uri ? sourceFiles.get(uri) : undefined;
        if (uri && doc && tsDoc && offset !== undefined && tsOffset !== undefined) {
            const pos = doc.positionAt(offset);
            const tsPos = tsDoc.positionAt(tsOffset);
            const references0 = _findReferences(tsDoc.uri, tsPos);
            let references = references0;
            if (sourceFile) {
                let isCssLocation = false;
                for (const cssSourceMap of sourceFile.getCssSourceMaps()) {
                    if (cssSourceMap.isSourceRange(pos)) {
                        isCssLocation = true;
                    }
                }
                if (isCssLocation) {
                    references = references0 === null || references0 === void 0 ? void 0 : references0.filter(ref => {
                        if (ref.uri === uri) {
                            for (const cssSourceMap of sourceFile.getCssSourceMaps()) {
                                if (cssSourceMap.isSourceRange(ref.range.start, ref.range.end)) {
                                    return false;
                                }
                            }
                        }
                        return true;
                    });
                }
                else {
                    references = references0 === null || references0 === void 0 ? void 0 : references0.filter(ref => {
                        if (ref.uri === uri) {
                            return false;
                        }
                        return true;
                    });
                }
            }
            else {
                references = references0 === null || references0 === void 0 ? void 0 : references0.filter(ref => {
                    if (ref.uri === uri) {
                        return false;
                    }
                    return true;
                });
            }
            const referencesCount = (_c = references === null || references === void 0 ? void 0 : references.length) !== null && _c !== void 0 ? _c : 0;
            codeLens.command = {
                title: referencesCount === 1 ? '1 reference' : `${referencesCount} references`,
                command: commands_1.Commands.SHOW_REFERENCES,
                arguments: [uri, codeLens.range.start, references0],
            };
        }
        return codeLens;
    };
}
exports.register = register;
//# sourceMappingURL=codeLensResolve.js.map