"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
const languageServices = require("../utils/languageServices");
function register({ sourceFiles }) {
    return (uri) => {
        const sourceFile = sourceFiles.get(uri);
        if (!sourceFile)
            return;
        const cssResult = getCssResult(sourceFile);
        return cssResult;
        function getCssResult(sourceFile) {
            const result = [];
            const sourceMaps = sourceFile.getCssSourceMaps();
            for (const sourceMap of sourceMaps) {
                const cssLanguageService = languageServices.getCssLanguageService(sourceMap.mappedDocument.languageId);
                if (!cssLanguageService || !sourceMap.stylesheet)
                    continue;
                let colors = cssLanguageService.findDocumentColors(sourceMap.mappedDocument, sourceMap.stylesheet);
                for (const color of colors) {
                    const vueRange = sourceMap.getSourceRange(color.range.start, color.range.end);
                    if (vueRange) {
                        result.push({
                            ...color,
                            range: vueRange,
                        });
                    }
                }
            }
            return result;
        }
    };
}
exports.register = register;
//# sourceMappingURL=documentColor.js.map