import type { IDescriptor } from '../types';
import { TextDocument } from 'vscode-languageserver-textdocument';
import { Ref } from '@vue/reactivity';
import { TsSourceMap, TeleportSourceMap } from '../utils/sourceMaps';
export declare function useScriptSetupGen(ts: typeof import('typescript'), vueDoc: Ref<TextDocument>, script: Ref<IDescriptor['script']>, scriptSetup: Ref<IDescriptor['scriptSetup']>, html: Ref<string | undefined>): {
    scriptSetupAst: import("@vue/reactivity").ComputedRef<{
        labels: {
            start: number;
            end: number;
            binarys: {
                parent: {
                    start: number;
                    end: number;
                };
                vars: {
                    isShortand: boolean;
                    inRoot: boolean;
                    start: number;
                    end: number;
                }[];
                left: {
                    start: number;
                    end: number;
                };
                right: {
                    start: number;
                    end: number;
                    isComputedCall: boolean;
                    withoutAs: {
                        start: number;
                        end: number;
                    };
                    as: {
                        start: number;
                        end: number;
                    } | undefined;
                } | undefined;
            }[];
            label: {
                start: number;
                end: number;
            };
            parent: {
                start: number;
                end: number;
            };
        }[];
        returnVarNames: {
            start: number;
            end: number;
        }[];
        defineProps: {
            start: number;
            end: number;
            args?: {
                start: number;
                end: number;
            } | undefined;
            typeArgs?: {
                start: number;
                end: number;
            } | undefined;
        } | undefined;
        defineEmit: {
            start: number;
            end: number;
            args?: {
                start: number;
                end: number;
            } | undefined;
            typeArgs?: {
                start: number;
                end: number;
            } | undefined;
        } | undefined;
        dollars: number[];
    } | undefined>;
    textDocument: import("@vue/reactivity").ComputedRef<TextDocument | undefined>;
    textDocumentForSuggestion: import("@vue/reactivity").ComputedRef<TextDocument | undefined>;
    textDocumentForTemplate: import("@vue/reactivity").ComputedRef<TextDocument | undefined>;
    sourceMap: import("@vue/reactivity").ComputedRef<TsSourceMap | undefined>;
    sourceMapForSuggestion: import("@vue/reactivity").ComputedRef<TsSourceMap | undefined>;
    sourceMapForTemplate: import("@vue/reactivity").ComputedRef<TsSourceMap | undefined>;
    teleportSourceMap: import("@vue/reactivity").ComputedRef<TeleportSourceMap | undefined>;
};
