import { Ref } from '@vue/reactivity';
import * as css from 'vscode-css-languageservice';
import { TextDocument } from 'vscode-languageserver-textdocument';
import { IDescriptor, ITemplateScriptData } from '../types';
import * as SourceMaps from '../utils/sourceMaps';
export declare function useTemplateScript(getUnreactiveDoc: () => TextDocument, template: Ref<IDescriptor['template']>, templateScriptData: ITemplateScriptData, styleDocuments: Ref<{
    textDocument: TextDocument;
    stylesheet: css.Stylesheet | undefined;
    links: {
        textDocument: TextDocument;
        stylesheet: css.Stylesheet;
    }[];
    module: boolean;
    scoped: boolean;
}[]>, styleSourceMaps: Ref<SourceMaps.CssSourceMap[]>, templateData: Ref<{
    html?: string;
    htmlToTemplate?: (start: number, end: number) => number | undefined;
} | undefined>): {
    templateCodeGens: import("@vue/reactivity").ComputedRef<{
        codeGen: {
            getText: () => string;
            getMappings: (sourceRangeParser?: ((data: SourceMaps.TsMappingData, range: SourceMaps.Range) => SourceMaps.Range) | undefined) => SourceMaps.Mapping<SourceMaps.TsMappingData>[];
            addText: (str: string) => {
                start: number;
                end: number;
            };
            addCode: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: SourceMaps.TsMappingData, extraSourceRanges?: SourceMaps.Range[] | undefined) => {
                start: number;
                end: number;
            };
            addMapping: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: SourceMaps.TsMappingData) => {
                start: number;
                end: number;
            };
            addMapping2: (mapping: SourceMaps.Mapping<SourceMaps.TsMappingData>) => void;
        };
        formatCodeGen: {
            getText: () => string;
            getMappings: (sourceRangeParser?: ((data: SourceMaps.TsMappingData, range: SourceMaps.Range) => SourceMaps.Range) | undefined) => SourceMaps.Mapping<SourceMaps.TsMappingData>[];
            addText: (str: string) => {
                start: number;
                end: number;
            };
            addCode: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: SourceMaps.TsMappingData, extraSourceRanges?: SourceMaps.Range[] | undefined) => {
                start: number;
                end: number;
            };
            addMapping: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: SourceMaps.TsMappingData) => {
                start: number;
                end: number;
            };
            addMapping2: (mapping: SourceMaps.Mapping<SourceMaps.TsMappingData>) => void;
        };
        cssCodeGen: {
            getText: () => string;
            getMappings: (sourceRangeParser?: ((data: undefined, range: SourceMaps.Range) => SourceMaps.Range) | undefined) => SourceMaps.Mapping<undefined>[];
            addText: (str: string) => {
                start: number;
                end: number;
            };
            addCode: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: undefined, extraSourceRanges?: SourceMaps.Range[] | undefined) => {
                start: number;
                end: number;
            };
            addMapping: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: undefined) => {
                start: number;
                end: number;
            };
            addMapping2: (mapping: SourceMaps.Mapping<undefined>) => void;
        };
        usedComponents: Set<string>;
        tagNames: Set<string>;
        attrNames: Set<string>;
    } | undefined>;
    sourceMap: import("@vue/reactivity").ComputedRef<SourceMaps.TsSourceMap | undefined>;
    textDocument: Ref<css.TextDocument | undefined>;
    textDocumentForFormatting: Ref<css.TextDocument | undefined>;
    sourceMapForFormatting: import("@vue/reactivity").ComputedRef<SourceMaps.TsSourceMap | undefined>;
    teleportSourceMap: Ref<SourceMaps.TeleportSourceMap | undefined>;
    cssTextDocument: import("@vue/reactivity").ComputedRef<{
        textDocument: css.TextDocument;
        stylesheet: css.Stylesheet;
        links: never[];
        module: boolean;
        scoped: boolean;
    } | undefined>;
    cssSourceMap: import("@vue/reactivity").ComputedRef<SourceMaps.CssSourceMap | undefined>;
    update: () => void;
};
